local function retire_phalanx_group()
    local gais = managers.groupai:state()
    local group = gais._phalanx_spawn_group
    local phalanx_minions = gais:phalanx_minions()
    local phalanx_vip = gais:phalanx_vip()
    if alive(phalanx_vip) then
        local brain = phalanx_vip:brain()

        if brain and brain:objective() then
            brain:set_objective(nil)
        end
    end

    if group then
        gais:_assign_group_to_retire(group)
    end

    if group and group.objective and group.objective.type == 'retire' then
        gais:unregister_phalanx_vip()
        for unit_key, unit in pairs(phalanx_minions) do
            gais:unregister_phalanx_minion(unit_key)
        end
        managers.game_play_central:announcer_say("cpw_a04")
        gais:phalanx_damage_reduction_disable()
        gais:phalanx_despawned()
    end
end

function CopLogicPhalanxVip._chk_should_breakup(data)
    local flee_health_ratio = tweak_data.group_ai.phalanx.vip.health_ratio_flee
    local vip_health_ratio = data.unit:character_damage():health_ratio()

    if vip_health_ratio <= flee_health_ratio then
       retire_phalanx_group()
    end
end

function CopLogicPhalanxMinion.chk_should_breakup()
    local phalanx_minion_count = managers.groupai:state():get_phalanx_minion_count()
    local min_count_minions = tweak_data.group_ai.phalanx.minions.min_count

    if phalanx_minion_count > 0 and phalanx_minion_count <= min_count_minions then
        retire_phalanx_group()
    end
end